/**
 * DevExtreme (cjs/ui/diagram/diagram.bar.js)
 * Version: 23.2.4 (build 24056-0112)
 * Build date: Sun Feb 25 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.default = void 0;
var _diagram = require("./diagram.importer");
let DiagramBar = function() {
    function DiagramBar(owner) {
        const {
            EventDispatcher: EventDispatcher
        } = (0, _diagram.getDiagram)();
        this.onChanged = new EventDispatcher;
        this._owner = owner
    }
    var _proto = DiagramBar.prototype;
    _proto.raiseBarCommandExecuted = function(key, parameter) {
        this.onChanged.raise("notifyBarCommandExecuted", parseInt(key), parameter)
    };
    _proto.getCommandKeys = function() {
        throw "Not Implemented"
    };
    _proto.setItemValue = function(key, value) {};
    _proto.setItemEnabled = function(key, enabled) {};
    _proto.setItemVisible = function(key, enabled) {};
    _proto.setEnabled = function(enabled) {};
    _proto.setItemSubItems = function(key, items) {};
    _proto.isVisible = function() {
        return true
    };
    _proto._getKeys = function(items) {
        const keys = items.reduce((commands, item) => {
            if (void 0 !== item.command) {
                commands.push(item.command)
            }
            if (item.items) {
                commands = commands.concat(this._getKeys(item.items))
            }
            return commands
        }, []);
        return keys
    };
    return DiagramBar
}();
var _default = DiagramBar;
exports.default = _default;
module.exports = exports.default;
module.exports.default = exports.default;
