/**
 * DevExtreme (esm/__internal/scheduler/options_validator/common/validation_functions.js)
 * Version: 23.2.4 (build 24056-0112)
 * Build date: Sun Feb 25 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
export var isInteger = value => Number.isInteger(value);
export var greaterThan = function(value, minimalValue) {
    var strict = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : true;
    return strict ? value > minimalValue : value >= minimalValue
};
export var lessThan = function(value, maximalValue) {
    var strict = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : true;
    return strict ? value < maximalValue : value <= maximalValue
};
export var inRange = (value, _ref) => {
    var [from, to] = _ref;
    return value >= from && value <= to
};
export var divisibleBy = (value, divider) => value % divider === 0;
